program

   map
     FillQ1 
   end

ListTotalClass Class,Type
InListYOffset    byte(2)
InList           Short
TotalList        Short
CopyFormat       Procedure
Init             Procedure(Short InList,Short TotalList)
SynchColumns     Procedure(Byte RightToLeft=False)
TakeEvent        Procedure
               end

LT ListTotalClass

Q1 Queue
S1  String(20)
D1  Decimal(10,2)
D2  Decimal(10,2)
D3  Decimal(10,2)
D4  Decimal(10,2)
   end

Q2 Queue(Q1)
   end

Window WINDOW('Listbox Totalling'),AT(,,284,152),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
       LIST,AT(5,5,272,129),USE(?List1),VSCROLL,FORMAT('55L(2)|M~Column 1~C(0)52R(2)|M~Column 2~C(0)@n-10.2b@52R(2)|M~Column 3~C(0)@n-10' &|
           '.2b@52R(2)|M~Column 4~C(0)@n-10.2b@52R(2)|M~Column 5~C(0)@n-10.2b@'),FROM(Q1)
       LIST,AT(9,137,241,10),USE(?List2),NOBAR,VSCROLL,COLOR(COLOR:BTNFACE),FORMAT('20L(2)|M'),FROM(Q2)
     END


  Code

  FillQ1
  Open(Window)
  LT.Init(?List1,?List2)
  Accept
    LT.TakeEvent
  end

FillQ1 PRocedure
Ndx Long

  Code

  Free(Q1)
  Clear(Q1)
  Free(Q2)
  Clear(Q2)
  Q2.S1 = 'Total'
  Loop Ndx = 1 to 14
    Q1.S1 = 'Record ' & Ndx
    Q1.D1 = Random(1,500000) * .01
    Q1.D2 = Random(1,500000) * .01
    Q1.D3 = Random(1,500000) * .01
    Q1.D4 = Random(1,500000) * .01
    Add(Q1)
    Q2.D1 += Q1.D1
    Q2.D2 += Q1.D2
    Q2.D3 += Q1.D3
    Q2.D4 += Q1.D4
  end
  Add(Q2)

ListTotalClass.CopyFormat   Procedure
Ndx Long

  Code

  Self.TotalList{PROP:Format} = Self.InList{PROP:Format}
  Self.TotalList{PROP:XPos} = Self.InList{PROP:XPos}
  Self.TotalList{PROP:YPos} = Self.InList{PROP:YPos} + Self.InList{PROP:Height} + Self.InListYOffset
  Self.TotalList{PROP:Width} = Self.InList{PROP:Width}
  Loop Ndx = 1 to 255
    If NOT Self.TotalList{PROPList:Exists,Ndx} then break.
    Self.TotalList{PROPList:Header,Ndx}=''
  end

ListTotalClass.Init         Procedure(Short InList,Short TotalList)

  Code

  Self.InList = InList
  Self.TotalList = TotalList
  Self.CopyFormat

ListTotalClass.SynchColumns Procedure(Byte RightToLeft=False)
Ndx Long

  Code

  Loop Ndx = 1 to 255
    If NOT Self.TotalList{PROPList:Exists,Ndx} then break.
    If RightToLeft
      Self.TotalList{PROPList:Width,Ndx} = Self.InList{PROPList:Width,Ndx}
    else
      Self.InList{PROPList:Width,Ndx} = Self.TotalList{PROPList:Width,Ndx}
    end
  end


ListTotalClass.TakeEvent    Procedure

  Code

  If Event() = Event:ColumnResize
    Case Field()
    of Self.InList
      Self.SynchColumns(1)
    of Self.TotalList
      Self.SynchColumns
    end
  end

